﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using System.Collections.ObjectModel;
using QtsUdp;
// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace SampleStoreUDP
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        private Service _udpSearchNas = new Service();
        private ObservableCollection<string> _naslist = new ObservableCollection<string>();
        private List<string> _tempNasList = new List<string>();
        public MainPage()
        {
            InitializeComponent();
            this.Loaded += MainPage_Loaded;
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            NASIPList.DataContext = _naslist;
        }

        private void buttonStartUDP_Click(object sender, RoutedEventArgs e)
        {
            NASIPList.Items.Clear();
            _tempNasList.Clear();
            ButtonStart.IsEnabled = false; //Only one usage of each socket address
            AsyncSearchResponseCallback responseCallback = new AsyncSearchResponseCallback(QTS_UDP_SearchNas_Response);
            _udpSearchNas.StartSearchNAS(this, responseCallback);
        }

        private void buttonStopUDP_Click(object sender, RoutedEventArgs e)
        {
            _udpSearchNas.StopSearchNAS();
            ButtonStart.IsEnabled = true;
        }

        void QTS_UDP_SearchNas_Response(ResponseCTX response)
        {
            if (_tempNasList.Contains(response.RemoteNASInfo.IPAddress) == true) //filter duplicate IP Address
                return;
            else
            {
                _tempNasList.Add(response.RemoteNASInfo.IPAddress);
                Dispatcher.RunAsync(Windows.UI.Core.CoreDispatcherPriority.High, () =>
                {
                    TextBlock Txtblock = new TextBlock();
                    Txtblock.Text = response.RemoteNASInfo.IPAddress + "\r\n";
                    NASIPList.Items.Add(Txtblock);
                });

            }
        }
    }
}
